# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from drc_com_common/FC2OCSLarge.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import jsk_recognition_msgs.msg
import visualization_msgs.msg
import geometry_msgs.msg
import sensor_msgs.msg
import genpy
import std_msgs.msg

class FC2OCSLarge(genpy.Message):
  _md5sum = "8ecdf8d19d56451734e33d850d3e0f0f"
  _type = "drc_com_common/FC2OCSLarge"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """sensor_msgs/PointCloud2 communication__point_cloud
sensor_msgs/PointCloud2 communication__laser_cloud
sensor_msgs/Image communication__image_rect_color
sensor_msgs/CameraInfo communication__camera_info
std_msgs/Float32 communication__image_width_scale
std_msgs/Float32 communication__image_height_scale
sensor_msgs/Image communication__panorama_image
sensor_msgs/Image communication__keyshot_image
std_msgs/Float32 communication__panorama_width_scale
std_msgs/Float32 communication__panorama_height_scale

# status of robot
std_msgs/UInt8 communication__robot_status
uint8 ROBOT_IDLE=1
uint8 ROBOT_MOVING=2

# for vehicle
geometry_msgs/PoseStamped communication__handle_pose
geometry_msgs/PoseStamped communication__crank_pose
jsk_recognition_msgs/TorusArray communication__drive__controller__current_steering
visualization_msgs/MarkerArray communication__drive__recognition__predicted_path__marker
# for locomotion
sensor_msgs/PointCloud2 communication__locomotion_cloud
sensor_msgs/PointCloud2 communication__normal_flip_cloud

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the "fields" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in include/sensor_msgs/image_encodings.h

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: sensor_msgs/CameraInfo
# This message defines meta information for a camera. It should be in a
# camera namespace on topic "camera_info" and accompanied by up to five
# image topics named:
#
#   image_raw - raw data from the camera driver, possibly Bayer encoded
#   image            - monochrome, distorted
#   image_color      - color, distorted
#   image_rect       - monochrome, rectified
#   image_rect_color - color, rectified
#
# The image_pipeline contains packages (image_proc, stereo_image_proc)
# for producing the four processed image topics from image_raw and
# camera_info. The meaning of the camera parameters are described in
# detail at http://www.ros.org/wiki/image_pipeline/CameraInfo.
#
# The image_geometry package provides a user-friendly interface to
# common operations using this meta information. If you want to, e.g.,
# project a 3d point into image coordinates, we strongly recommend
# using image_geometry.
#
# If the camera is uncalibrated, the matrices D, K, R, P should be left
# zeroed out. In particular, clients may assume that K[0] == 0.0
# indicates an uncalibrated camera.

#######################################################################
#                     Image acquisition info                          #
#######################################################################

# Time of image acquisition, camera coordinate frame ID
Header header    # Header timestamp should be acquisition time of image
                 # Header frame_id should be optical frame of camera
                 # origin of frame should be optical center of camera
                 # +x should point to the right in the image
                 # +y should point down in the image
                 # +z should point into the plane of the image


#######################################################################
#                      Calibration Parameters                         #
#######################################################################
# These are fixed during camera calibration. Their values will be the #
# same in all messages until the camera is recalibrated. Note that    #
# self-calibrating systems may "recalibrate" frequently.              #
#                                                                     #
# The internal parameters can be used to warp a raw (distorted) image #
# to:                                                                 #
#   1. An undistorted image (requires D and K)                        #
#   2. A rectified image (requires D, K, R)                           #
# The projection matrix P projects 3D points into the rectified image.#
#######################################################################

# The image dimensions with which the camera was calibrated. Normally
# this will be the full camera resolution in pixels.
uint32 height
uint32 width

# The distortion model used. Supported models are listed in
# sensor_msgs/distortion_models.h. For most cameras, "plumb_bob" - a
# simple model of radial and tangential distortion - is sufficent.
string distortion_model

# The distortion parameters, size depending on the distortion model.
# For "plumb_bob", the 5 parameters are: (k1, k2, t1, t2, k3).
float64[] D

# Intrinsic camera matrix for the raw (distorted) images.
#     [fx  0 cx]
# K = [ 0 fy cy]
#     [ 0  0  1]
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy).
float64[9]  K # 3x3 row-major matrix

# Rectification matrix (stereo cameras only)
# A rotation matrix aligning the camera coordinate system to the ideal
# stereo image plane so that epipolar lines in both stereo images are
# parallel.
float64[9]  R # 3x3 row-major matrix

# Projection/camera matrix
#     [fx'  0  cx' Tx]
# P = [ 0  fy' cy' Ty]
#     [ 0   0   1   0]
# By convention, this matrix specifies the intrinsic (camera) matrix
#  of the processed (rectified) image. That is, the left 3x3 portion
#  is the normal camera intrinsic matrix for the rectified image.
# It projects 3D points in the camera coordinate frame to 2D pixel
#  coordinates using the focal lengths (fx', fy') and principal point
#  (cx', cy') - these may differ from the values in K.
# For monocular cameras, Tx = Ty = 0. Normally, monocular cameras will
#  also have R = the identity and P[1:3,1:3] = K.
# For a stereo pair, the fourth column [Tx Ty 0]' is related to the
#  position of the optical center of the second camera in the first
#  camera's frame. We assume Tz = 0 so both cameras are in the same
#  stereo image plane. The first camera always has Tx = Ty = 0. For
#  the right (second) camera of a horizontal stereo pair, Ty = 0 and
#  Tx = -fx' * B, where B is the baseline between the cameras.
# Given a 3D point [X Y Z]', the projection (x, y) of the point onto
#  the rectified image is given by:
#  [u v w]' = P * [X Y Z 1]'
#         x = u / w
#         y = v / w
#  This holds for both images of a stereo pair.
float64[12] P # 3x4 row-major matrix


#######################################################################
#                      Operational Parameters                         #
#######################################################################
# These define the image region actually captured by the camera       #
# driver. Although they affect the geometry of the output image, they #
# may be changed freely without recalibrating the camera.             #
#######################################################################

# Binning refers here to any camera setting which combines rectangular
#  neighborhoods of pixels into larger "super-pixels." It reduces the
#  resolution of the output image to
#  (width / binning_x) x (height / binning_y).
# The default values binning_x = binning_y = 0 is considered the same
#  as binning_x = binning_y = 1 (no subsampling).
uint32 binning_x
uint32 binning_y

# Region of interest (subwindow of full camera resolution), given in
#  full resolution (unbinned) image coordinates. A particular ROI
#  always denotes the same window of pixels on the camera sensor,
#  regardless of binning settings.
# The default setting of roi (all values 0) is considered the same as
#  full resolution (roi.width = width, roi.height = height).
RegionOfInterest roi

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image.
#
# When used to specify the ROI setting of the camera when the image was
# taken, the height and width fields should either match the height and
# width fields for the associated image; or height = width = 0
# indicates that the full resolution image was captured.

uint32 x_offset  # Leftmost pixel of the ROI
                 # (0 if the ROI includes the left edge of the image)
uint32 y_offset  # Topmost pixel of the ROI
                 # (0 if the ROI includes the top edge of the image)
uint32 height    # Height of ROI
uint32 width     # Width of ROI

# True if a distinct rectified ROI should be calculated from the "raw"
# ROI in this message. Typically this should be False if the full image
# is captured (ROI not used), and True if a subwindow is captured (ROI
# used).
bool do_rectify

================================================================================
MSG: std_msgs/Float32
float32 data
================================================================================
MSG: std_msgs/UInt8
uint8 data

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: jsk_recognition_msgs/TorusArray
Header header
Torus[] toruses

================================================================================
MSG: jsk_recognition_msgs/Torus
Header header
bool failure
geometry_msgs/Pose pose
float64 large_radius
float64 small_radius

================================================================================
MSG: visualization_msgs/MarkerArray
Marker[] markers

================================================================================
MSG: visualization_msgs/Marker
# See http://www.ros.org/wiki/rviz/DisplayTypes/Marker and http://www.ros.org/wiki/rviz/Tutorials/Markers%3A%20Basic%20Shapes for more information on using this message with rviz

uint8 ARROW=0
uint8 CUBE=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 LINE_STRIP=4
uint8 LINE_LIST=5
uint8 CUBE_LIST=6
uint8 SPHERE_LIST=7
uint8 POINTS=8
uint8 TEXT_VIEW_FACING=9
uint8 MESH_RESOURCE=10
uint8 TRIANGLE_LIST=11

uint8 ADD=0
uint8 MODIFY=0
uint8 DELETE=2
#uint8 DELETEALL=3 # TODO: enable for ROS-J, disabled for now but functionality is still there. Allows one to clear all markers in plugin

Header header                        # header for time/frame information
string ns                            # Namespace to place this object in... used in conjunction with id to create a unique name for the object
int32 id 		                         # object ID useful in conjunction with the namespace for manipulating and deleting the object later
int32 type 		                       # Type of object
int32 action 	                       # 0 add/modify an object, 1 (deprecated), 2 deletes an object, 3 deletes all objects
geometry_msgs/Pose pose                 # Pose of the object
geometry_msgs/Vector3 scale             # Scale of the object 1,1,1 means default (usually 1 meter square)
std_msgs/ColorRGBA color             # Color [0.0-1.0]
duration lifetime                    # How long the object should last before being automatically deleted.  0 means forever
bool frame_locked                    # If this marker should be frame-locked, i.e. retransformed into its frame every timestep

#Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
geometry_msgs/Point[] points
#Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
#number of colors must either be 0 or equal to the number of points
#NOTE: alpha is not yet used
std_msgs/ColorRGBA[] colors

# NOTE: only used for text markers
string text

# NOTE: only used for MESH_RESOURCE markers
string mesh_resource
bool mesh_use_embedded_materials

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a
"""
  # Pseudo-constants
  ROBOT_IDLE = 1
  ROBOT_MOVING = 2

  __slots__ = ['communication__point_cloud','communication__laser_cloud','communication__image_rect_color','communication__camera_info','communication__image_width_scale','communication__image_height_scale','communication__panorama_image','communication__keyshot_image','communication__panorama_width_scale','communication__panorama_height_scale','communication__robot_status','communication__handle_pose','communication__crank_pose','communication__drive__controller__current_steering','communication__drive__recognition__predicted_path__marker','communication__locomotion_cloud','communication__normal_flip_cloud']
  _slot_types = ['sensor_msgs/PointCloud2','sensor_msgs/PointCloud2','sensor_msgs/Image','sensor_msgs/CameraInfo','std_msgs/Float32','std_msgs/Float32','sensor_msgs/Image','sensor_msgs/Image','std_msgs/Float32','std_msgs/Float32','std_msgs/UInt8','geometry_msgs/PoseStamped','geometry_msgs/PoseStamped','jsk_recognition_msgs/TorusArray','visualization_msgs/MarkerArray','sensor_msgs/PointCloud2','sensor_msgs/PointCloud2']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       communication__point_cloud,communication__laser_cloud,communication__image_rect_color,communication__camera_info,communication__image_width_scale,communication__image_height_scale,communication__panorama_image,communication__keyshot_image,communication__panorama_width_scale,communication__panorama_height_scale,communication__robot_status,communication__handle_pose,communication__crank_pose,communication__drive__controller__current_steering,communication__drive__recognition__predicted_path__marker,communication__locomotion_cloud,communication__normal_flip_cloud

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(FC2OCSLarge, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.communication__point_cloud is None:
        self.communication__point_cloud = sensor_msgs.msg.PointCloud2()
      if self.communication__laser_cloud is None:
        self.communication__laser_cloud = sensor_msgs.msg.PointCloud2()
      if self.communication__image_rect_color is None:
        self.communication__image_rect_color = sensor_msgs.msg.Image()
      if self.communication__camera_info is None:
        self.communication__camera_info = sensor_msgs.msg.CameraInfo()
      if self.communication__image_width_scale is None:
        self.communication__image_width_scale = std_msgs.msg.Float32()
      if self.communication__image_height_scale is None:
        self.communication__image_height_scale = std_msgs.msg.Float32()
      if self.communication__panorama_image is None:
        self.communication__panorama_image = sensor_msgs.msg.Image()
      if self.communication__keyshot_image is None:
        self.communication__keyshot_image = sensor_msgs.msg.Image()
      if self.communication__panorama_width_scale is None:
        self.communication__panorama_width_scale = std_msgs.msg.Float32()
      if self.communication__panorama_height_scale is None:
        self.communication__panorama_height_scale = std_msgs.msg.Float32()
      if self.communication__robot_status is None:
        self.communication__robot_status = std_msgs.msg.UInt8()
      if self.communication__handle_pose is None:
        self.communication__handle_pose = geometry_msgs.msg.PoseStamped()
      if self.communication__crank_pose is None:
        self.communication__crank_pose = geometry_msgs.msg.PoseStamped()
      if self.communication__drive__controller__current_steering is None:
        self.communication__drive__controller__current_steering = jsk_recognition_msgs.msg.TorusArray()
      if self.communication__drive__recognition__predicted_path__marker is None:
        self.communication__drive__recognition__predicted_path__marker = visualization_msgs.msg.MarkerArray()
      if self.communication__locomotion_cloud is None:
        self.communication__locomotion_cloud = sensor_msgs.msg.PointCloud2()
      if self.communication__normal_flip_cloud is None:
        self.communication__normal_flip_cloud = sensor_msgs.msg.PointCloud2()
    else:
      self.communication__point_cloud = sensor_msgs.msg.PointCloud2()
      self.communication__laser_cloud = sensor_msgs.msg.PointCloud2()
      self.communication__image_rect_color = sensor_msgs.msg.Image()
      self.communication__camera_info = sensor_msgs.msg.CameraInfo()
      self.communication__image_width_scale = std_msgs.msg.Float32()
      self.communication__image_height_scale = std_msgs.msg.Float32()
      self.communication__panorama_image = sensor_msgs.msg.Image()
      self.communication__keyshot_image = sensor_msgs.msg.Image()
      self.communication__panorama_width_scale = std_msgs.msg.Float32()
      self.communication__panorama_height_scale = std_msgs.msg.Float32()
      self.communication__robot_status = std_msgs.msg.UInt8()
      self.communication__handle_pose = geometry_msgs.msg.PoseStamped()
      self.communication__crank_pose = geometry_msgs.msg.PoseStamped()
      self.communication__drive__controller__current_steering = jsk_recognition_msgs.msg.TorusArray()
      self.communication__drive__recognition__predicted_path__marker = visualization_msgs.msg.MarkerArray()
      self.communication__locomotion_cloud = sensor_msgs.msg.PointCloud2()
      self.communication__normal_flip_cloud = sensor_msgs.msg.PointCloud2()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.communication__point_cloud.header.seq, _x.communication__point_cloud.header.stamp.secs, _x.communication__point_cloud.header.stamp.nsecs))
      _x = self.communication__point_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__point_cloud.height, _x.communication__point_cloud.width))
      length = len(self.communication__point_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.communication__point_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.communication__point_cloud.is_bigendian, _x.communication__point_cloud.point_step, _x.communication__point_cloud.row_step))
      _x = self.communication__point_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_B3I.pack(_x.communication__point_cloud.is_dense, _x.communication__laser_cloud.header.seq, _x.communication__laser_cloud.header.stamp.secs, _x.communication__laser_cloud.header.stamp.nsecs))
      _x = self.communication__laser_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__laser_cloud.height, _x.communication__laser_cloud.width))
      length = len(self.communication__laser_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.communication__laser_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.communication__laser_cloud.is_bigendian, _x.communication__laser_cloud.point_step, _x.communication__laser_cloud.row_step))
      _x = self.communication__laser_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_B3I.pack(_x.communication__laser_cloud.is_dense, _x.communication__image_rect_color.header.seq, _x.communication__image_rect_color.header.stamp.secs, _x.communication__image_rect_color.header.stamp.nsecs))
      _x = self.communication__image_rect_color.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__image_rect_color.height, _x.communication__image_rect_color.width))
      _x = self.communication__image_rect_color.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.communication__image_rect_color.is_bigendian, _x.communication__image_rect_color.step))
      _x = self.communication__image_rect_color.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.communication__camera_info.header.seq, _x.communication__camera_info.header.stamp.secs, _x.communication__camera_info.header.stamp.nsecs))
      _x = self.communication__camera_info.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__camera_info.height, _x.communication__camera_info.width))
      _x = self.communication__camera_info.distortion_model
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.communication__camera_info.D)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.communication__camera_info.D))
      buff.write(_struct_9d.pack(*self.communication__camera_info.K))
      buff.write(_struct_9d.pack(*self.communication__camera_info.R))
      buff.write(_struct_12d.pack(*self.communication__camera_info.P))
      _x = self
      buff.write(_struct_6IB2f3I.pack(_x.communication__camera_info.binning_x, _x.communication__camera_info.binning_y, _x.communication__camera_info.roi.x_offset, _x.communication__camera_info.roi.y_offset, _x.communication__camera_info.roi.height, _x.communication__camera_info.roi.width, _x.communication__camera_info.roi.do_rectify, _x.communication__image_width_scale.data, _x.communication__image_height_scale.data, _x.communication__panorama_image.header.seq, _x.communication__panorama_image.header.stamp.secs, _x.communication__panorama_image.header.stamp.nsecs))
      _x = self.communication__panorama_image.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__panorama_image.height, _x.communication__panorama_image.width))
      _x = self.communication__panorama_image.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.communication__panorama_image.is_bigendian, _x.communication__panorama_image.step))
      _x = self.communication__panorama_image.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.communication__keyshot_image.header.seq, _x.communication__keyshot_image.header.stamp.secs, _x.communication__keyshot_image.header.stamp.nsecs))
      _x = self.communication__keyshot_image.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__keyshot_image.height, _x.communication__keyshot_image.width))
      _x = self.communication__keyshot_image.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.communication__keyshot_image.is_bigendian, _x.communication__keyshot_image.step))
      _x = self.communication__keyshot_image.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2fB3I.pack(_x.communication__panorama_width_scale.data, _x.communication__panorama_height_scale.data, _x.communication__robot_status.data, _x.communication__handle_pose.header.seq, _x.communication__handle_pose.header.stamp.secs, _x.communication__handle_pose.header.stamp.nsecs))
      _x = self.communication__handle_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.communication__handle_pose.pose.position.x, _x.communication__handle_pose.pose.position.y, _x.communication__handle_pose.pose.position.z, _x.communication__handle_pose.pose.orientation.x, _x.communication__handle_pose.pose.orientation.y, _x.communication__handle_pose.pose.orientation.z, _x.communication__handle_pose.pose.orientation.w, _x.communication__crank_pose.header.seq, _x.communication__crank_pose.header.stamp.secs, _x.communication__crank_pose.header.stamp.nsecs))
      _x = self.communication__crank_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.communication__crank_pose.pose.position.x, _x.communication__crank_pose.pose.position.y, _x.communication__crank_pose.pose.position.z, _x.communication__crank_pose.pose.orientation.x, _x.communication__crank_pose.pose.orientation.y, _x.communication__crank_pose.pose.orientation.z, _x.communication__crank_pose.pose.orientation.w, _x.communication__drive__controller__current_steering.header.seq, _x.communication__drive__controller__current_steering.header.stamp.secs, _x.communication__drive__controller__current_steering.header.stamp.nsecs))
      _x = self.communication__drive__controller__current_steering.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.communication__drive__controller__current_steering.toruses)
      buff.write(_struct_I.pack(length))
      for val1 in self.communication__drive__controller__current_steering.toruses:
        _v1 = val1.header
        buff.write(_struct_I.pack(_v1.seq))
        _v2 = _v1.stamp
        _x = _v2
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v1.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(val1.failure))
        _v3 = val1.pose
        _v4 = _v3.position
        _x = _v4
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v5 = _v3.orientation
        _x = _v5
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_2d.pack(_x.large_radius, _x.small_radius))
      length = len(self.communication__drive__recognition__predicted_path__marker.markers)
      buff.write(_struct_I.pack(length))
      for val1 in self.communication__drive__recognition__predicted_path__marker.markers:
        _v6 = val1.header
        buff.write(_struct_I.pack(_v6.seq))
        _v7 = _v6.stamp
        _x = _v7
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v6.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.ns
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_3i.pack(_x.id, _x.type, _x.action))
        _v8 = val1.pose
        _v9 = _v8.position
        _x = _v9
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v10 = _v8.orientation
        _x = _v10
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v11 = val1.scale
        _x = _v11
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v12 = val1.color
        _x = _v12
        buff.write(_struct_4f.pack(_x.r, _x.g, _x.b, _x.a))
        _v13 = val1.lifetime
        _x = _v13
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        buff.write(_struct_B.pack(val1.frame_locked))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_struct_4f.pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.text
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.mesh_resource
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(val1.mesh_use_embedded_materials))
      _x = self
      buff.write(_struct_3I.pack(_x.communication__locomotion_cloud.header.seq, _x.communication__locomotion_cloud.header.stamp.secs, _x.communication__locomotion_cloud.header.stamp.nsecs))
      _x = self.communication__locomotion_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__locomotion_cloud.height, _x.communication__locomotion_cloud.width))
      length = len(self.communication__locomotion_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.communication__locomotion_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.communication__locomotion_cloud.is_bigendian, _x.communication__locomotion_cloud.point_step, _x.communication__locomotion_cloud.row_step))
      _x = self.communication__locomotion_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_B3I.pack(_x.communication__locomotion_cloud.is_dense, _x.communication__normal_flip_cloud.header.seq, _x.communication__normal_flip_cloud.header.stamp.secs, _x.communication__normal_flip_cloud.header.stamp.nsecs))
      _x = self.communication__normal_flip_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__normal_flip_cloud.height, _x.communication__normal_flip_cloud.width))
      length = len(self.communication__normal_flip_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.communication__normal_flip_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.communication__normal_flip_cloud.is_bigendian, _x.communication__normal_flip_cloud.point_step, _x.communication__normal_flip_cloud.row_step))
      _x = self.communication__normal_flip_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.communication__normal_flip_cloud.is_dense))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.communication__point_cloud is None:
        self.communication__point_cloud = sensor_msgs.msg.PointCloud2()
      if self.communication__laser_cloud is None:
        self.communication__laser_cloud = sensor_msgs.msg.PointCloud2()
      if self.communication__image_rect_color is None:
        self.communication__image_rect_color = sensor_msgs.msg.Image()
      if self.communication__camera_info is None:
        self.communication__camera_info = sensor_msgs.msg.CameraInfo()
      if self.communication__image_width_scale is None:
        self.communication__image_width_scale = std_msgs.msg.Float32()
      if self.communication__image_height_scale is None:
        self.communication__image_height_scale = std_msgs.msg.Float32()
      if self.communication__panorama_image is None:
        self.communication__panorama_image = sensor_msgs.msg.Image()
      if self.communication__keyshot_image is None:
        self.communication__keyshot_image = sensor_msgs.msg.Image()
      if self.communication__panorama_width_scale is None:
        self.communication__panorama_width_scale = std_msgs.msg.Float32()
      if self.communication__panorama_height_scale is None:
        self.communication__panorama_height_scale = std_msgs.msg.Float32()
      if self.communication__robot_status is None:
        self.communication__robot_status = std_msgs.msg.UInt8()
      if self.communication__handle_pose is None:
        self.communication__handle_pose = geometry_msgs.msg.PoseStamped()
      if self.communication__crank_pose is None:
        self.communication__crank_pose = geometry_msgs.msg.PoseStamped()
      if self.communication__drive__controller__current_steering is None:
        self.communication__drive__controller__current_steering = jsk_recognition_msgs.msg.TorusArray()
      if self.communication__drive__recognition__predicted_path__marker is None:
        self.communication__drive__recognition__predicted_path__marker = visualization_msgs.msg.MarkerArray()
      if self.communication__locomotion_cloud is None:
        self.communication__locomotion_cloud = sensor_msgs.msg.PointCloud2()
      if self.communication__normal_flip_cloud is None:
        self.communication__normal_flip_cloud = sensor_msgs.msg.PointCloud2()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.communication__point_cloud.header.seq, _x.communication__point_cloud.header.stamp.secs, _x.communication__point_cloud.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__point_cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__point_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__point_cloud.height, _x.communication__point_cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.communication__point_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.communication__point_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.communication__point_cloud.is_bigendian, _x.communication__point_cloud.point_step, _x.communication__point_cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.communication__point_cloud.is_bigendian = bool(self.communication__point_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__point_cloud.data = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.communication__point_cloud.is_dense, _x.communication__laser_cloud.header.seq, _x.communication__laser_cloud.header.stamp.secs, _x.communication__laser_cloud.header.stamp.nsecs,) = _struct_B3I.unpack(str[start:end])
      self.communication__point_cloud.is_dense = bool(self.communication__point_cloud.is_dense)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__laser_cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__laser_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__laser_cloud.height, _x.communication__laser_cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.communication__laser_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.communication__laser_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.communication__laser_cloud.is_bigendian, _x.communication__laser_cloud.point_step, _x.communication__laser_cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.communication__laser_cloud.is_bigendian = bool(self.communication__laser_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__laser_cloud.data = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.communication__laser_cloud.is_dense, _x.communication__image_rect_color.header.seq, _x.communication__image_rect_color.header.stamp.secs, _x.communication__image_rect_color.header.stamp.nsecs,) = _struct_B3I.unpack(str[start:end])
      self.communication__laser_cloud.is_dense = bool(self.communication__laser_cloud.is_dense)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__image_rect_color.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__image_rect_color.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__image_rect_color.height, _x.communication__image_rect_color.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__image_rect_color.encoding = str[start:end].decode('utf-8')
      else:
        self.communication__image_rect_color.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.communication__image_rect_color.is_bigendian, _x.communication__image_rect_color.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__image_rect_color.data = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.communication__camera_info.header.seq, _x.communication__camera_info.header.stamp.secs, _x.communication__camera_info.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__camera_info.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__camera_info.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__camera_info.height, _x.communication__camera_info.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__camera_info.distortion_model = str[start:end].decode('utf-8')
      else:
        self.communication__camera_info.distortion_model = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.communication__camera_info.D = struct.unpack(pattern, str[start:end])
      start = end
      end += 72
      self.communication__camera_info.K = _struct_9d.unpack(str[start:end])
      start = end
      end += 72
      self.communication__camera_info.R = _struct_9d.unpack(str[start:end])
      start = end
      end += 96
      self.communication__camera_info.P = _struct_12d.unpack(str[start:end])
      _x = self
      start = end
      end += 45
      (_x.communication__camera_info.binning_x, _x.communication__camera_info.binning_y, _x.communication__camera_info.roi.x_offset, _x.communication__camera_info.roi.y_offset, _x.communication__camera_info.roi.height, _x.communication__camera_info.roi.width, _x.communication__camera_info.roi.do_rectify, _x.communication__image_width_scale.data, _x.communication__image_height_scale.data, _x.communication__panorama_image.header.seq, _x.communication__panorama_image.header.stamp.secs, _x.communication__panorama_image.header.stamp.nsecs,) = _struct_6IB2f3I.unpack(str[start:end])
      self.communication__camera_info.roi.do_rectify = bool(self.communication__camera_info.roi.do_rectify)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__panorama_image.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__panorama_image.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__panorama_image.height, _x.communication__panorama_image.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__panorama_image.encoding = str[start:end].decode('utf-8')
      else:
        self.communication__panorama_image.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.communication__panorama_image.is_bigendian, _x.communication__panorama_image.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__panorama_image.data = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.communication__keyshot_image.header.seq, _x.communication__keyshot_image.header.stamp.secs, _x.communication__keyshot_image.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__keyshot_image.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__keyshot_image.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__keyshot_image.height, _x.communication__keyshot_image.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__keyshot_image.encoding = str[start:end].decode('utf-8')
      else:
        self.communication__keyshot_image.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.communication__keyshot_image.is_bigendian, _x.communication__keyshot_image.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__keyshot_image.data = str[start:end]
      _x = self
      start = end
      end += 21
      (_x.communication__panorama_width_scale.data, _x.communication__panorama_height_scale.data, _x.communication__robot_status.data, _x.communication__handle_pose.header.seq, _x.communication__handle_pose.header.stamp.secs, _x.communication__handle_pose.header.stamp.nsecs,) = _struct_2fB3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__handle_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__handle_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.communication__handle_pose.pose.position.x, _x.communication__handle_pose.pose.position.y, _x.communication__handle_pose.pose.position.z, _x.communication__handle_pose.pose.orientation.x, _x.communication__handle_pose.pose.orientation.y, _x.communication__handle_pose.pose.orientation.z, _x.communication__handle_pose.pose.orientation.w, _x.communication__crank_pose.header.seq, _x.communication__crank_pose.header.stamp.secs, _x.communication__crank_pose.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__crank_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__crank_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.communication__crank_pose.pose.position.x, _x.communication__crank_pose.pose.position.y, _x.communication__crank_pose.pose.position.z, _x.communication__crank_pose.pose.orientation.x, _x.communication__crank_pose.pose.orientation.y, _x.communication__crank_pose.pose.orientation.z, _x.communication__crank_pose.pose.orientation.w, _x.communication__drive__controller__current_steering.header.seq, _x.communication__drive__controller__current_steering.header.stamp.secs, _x.communication__drive__controller__current_steering.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__drive__controller__current_steering.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__drive__controller__current_steering.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.communication__drive__controller__current_steering.toruses = []
      for i in range(0, length):
        val1 = jsk_recognition_msgs.msg.Torus()
        _v14 = val1.header
        start = end
        end += 4
        (_v14.seq,) = _struct_I.unpack(str[start:end])
        _v15 = _v14.stamp
        _x = _v15
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v14.frame_id = str[start:end].decode('utf-8')
        else:
          _v14.frame_id = str[start:end]
        start = end
        end += 1
        (val1.failure,) = _struct_B.unpack(str[start:end])
        val1.failure = bool(val1.failure)
        _v16 = val1.pose
        _v17 = _v16.position
        _x = _v17
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v18 = _v16.orientation
        _x = _v18
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.large_radius, _x.small_radius,) = _struct_2d.unpack(str[start:end])
        self.communication__drive__controller__current_steering.toruses.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.communication__drive__recognition__predicted_path__marker.markers = []
      for i in range(0, length):
        val1 = visualization_msgs.msg.Marker()
        _v19 = val1.header
        start = end
        end += 4
        (_v19.seq,) = _struct_I.unpack(str[start:end])
        _v20 = _v19.stamp
        _x = _v20
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v19.frame_id = str[start:end].decode('utf-8')
        else:
          _v19.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.ns = str[start:end].decode('utf-8')
        else:
          val1.ns = str[start:end]
        _x = val1
        start = end
        end += 12
        (_x.id, _x.type, _x.action,) = _struct_3i.unpack(str[start:end])
        _v21 = val1.pose
        _v22 = _v21.position
        _x = _v22
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v23 = _v21.orientation
        _x = _v23
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _v24 = val1.scale
        _x = _v24
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v25 = val1.color
        _x = _v25
        start = end
        end += 16
        (_x.r, _x.g, _x.b, _x.a,) = _struct_4f.unpack(str[start:end])
        _v26 = val1.lifetime
        _x = _v26
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _struct_B.unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          val1.points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in range(0, length):
          val2 = std_msgs.msg.ColorRGBA()
          _x = val2
          start = end
          end += 16
          (_x.r, _x.g, _x.b, _x.a,) = _struct_4f.unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.text = str[start:end].decode('utf-8')
        else:
          val1.text = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.mesh_resource = str[start:end].decode('utf-8')
        else:
          val1.mesh_resource = str[start:end]
        start = end
        end += 1
        (val1.mesh_use_embedded_materials,) = _struct_B.unpack(str[start:end])
        val1.mesh_use_embedded_materials = bool(val1.mesh_use_embedded_materials)
        self.communication__drive__recognition__predicted_path__marker.markers.append(val1)
      _x = self
      start = end
      end += 12
      (_x.communication__locomotion_cloud.header.seq, _x.communication__locomotion_cloud.header.stamp.secs, _x.communication__locomotion_cloud.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__locomotion_cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__locomotion_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__locomotion_cloud.height, _x.communication__locomotion_cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.communication__locomotion_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.communication__locomotion_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.communication__locomotion_cloud.is_bigendian, _x.communication__locomotion_cloud.point_step, _x.communication__locomotion_cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.communication__locomotion_cloud.is_bigendian = bool(self.communication__locomotion_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__locomotion_cloud.data = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.communication__locomotion_cloud.is_dense, _x.communication__normal_flip_cloud.header.seq, _x.communication__normal_flip_cloud.header.stamp.secs, _x.communication__normal_flip_cloud.header.stamp.nsecs,) = _struct_B3I.unpack(str[start:end])
      self.communication__locomotion_cloud.is_dense = bool(self.communication__locomotion_cloud.is_dense)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__normal_flip_cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__normal_flip_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__normal_flip_cloud.height, _x.communication__normal_flip_cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.communication__normal_flip_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.communication__normal_flip_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.communication__normal_flip_cloud.is_bigendian, _x.communication__normal_flip_cloud.point_step, _x.communication__normal_flip_cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.communication__normal_flip_cloud.is_bigendian = bool(self.communication__normal_flip_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__normal_flip_cloud.data = str[start:end]
      start = end
      end += 1
      (self.communication__normal_flip_cloud.is_dense,) = _struct_B.unpack(str[start:end])
      self.communication__normal_flip_cloud.is_dense = bool(self.communication__normal_flip_cloud.is_dense)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.communication__point_cloud.header.seq, _x.communication__point_cloud.header.stamp.secs, _x.communication__point_cloud.header.stamp.nsecs))
      _x = self.communication__point_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__point_cloud.height, _x.communication__point_cloud.width))
      length = len(self.communication__point_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.communication__point_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.communication__point_cloud.is_bigendian, _x.communication__point_cloud.point_step, _x.communication__point_cloud.row_step))
      _x = self.communication__point_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_B3I.pack(_x.communication__point_cloud.is_dense, _x.communication__laser_cloud.header.seq, _x.communication__laser_cloud.header.stamp.secs, _x.communication__laser_cloud.header.stamp.nsecs))
      _x = self.communication__laser_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__laser_cloud.height, _x.communication__laser_cloud.width))
      length = len(self.communication__laser_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.communication__laser_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.communication__laser_cloud.is_bigendian, _x.communication__laser_cloud.point_step, _x.communication__laser_cloud.row_step))
      _x = self.communication__laser_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_B3I.pack(_x.communication__laser_cloud.is_dense, _x.communication__image_rect_color.header.seq, _x.communication__image_rect_color.header.stamp.secs, _x.communication__image_rect_color.header.stamp.nsecs))
      _x = self.communication__image_rect_color.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__image_rect_color.height, _x.communication__image_rect_color.width))
      _x = self.communication__image_rect_color.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.communication__image_rect_color.is_bigendian, _x.communication__image_rect_color.step))
      _x = self.communication__image_rect_color.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.communication__camera_info.header.seq, _x.communication__camera_info.header.stamp.secs, _x.communication__camera_info.header.stamp.nsecs))
      _x = self.communication__camera_info.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__camera_info.height, _x.communication__camera_info.width))
      _x = self.communication__camera_info.distortion_model
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.communication__camera_info.D)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.communication__camera_info.D.tostring())
      buff.write(self.communication__camera_info.K.tostring())
      buff.write(self.communication__camera_info.R.tostring())
      buff.write(self.communication__camera_info.P.tostring())
      _x = self
      buff.write(_struct_6IB2f3I.pack(_x.communication__camera_info.binning_x, _x.communication__camera_info.binning_y, _x.communication__camera_info.roi.x_offset, _x.communication__camera_info.roi.y_offset, _x.communication__camera_info.roi.height, _x.communication__camera_info.roi.width, _x.communication__camera_info.roi.do_rectify, _x.communication__image_width_scale.data, _x.communication__image_height_scale.data, _x.communication__panorama_image.header.seq, _x.communication__panorama_image.header.stamp.secs, _x.communication__panorama_image.header.stamp.nsecs))
      _x = self.communication__panorama_image.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__panorama_image.height, _x.communication__panorama_image.width))
      _x = self.communication__panorama_image.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.communication__panorama_image.is_bigendian, _x.communication__panorama_image.step))
      _x = self.communication__panorama_image.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.communication__keyshot_image.header.seq, _x.communication__keyshot_image.header.stamp.secs, _x.communication__keyshot_image.header.stamp.nsecs))
      _x = self.communication__keyshot_image.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__keyshot_image.height, _x.communication__keyshot_image.width))
      _x = self.communication__keyshot_image.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.communication__keyshot_image.is_bigendian, _x.communication__keyshot_image.step))
      _x = self.communication__keyshot_image.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2fB3I.pack(_x.communication__panorama_width_scale.data, _x.communication__panorama_height_scale.data, _x.communication__robot_status.data, _x.communication__handle_pose.header.seq, _x.communication__handle_pose.header.stamp.secs, _x.communication__handle_pose.header.stamp.nsecs))
      _x = self.communication__handle_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.communication__handle_pose.pose.position.x, _x.communication__handle_pose.pose.position.y, _x.communication__handle_pose.pose.position.z, _x.communication__handle_pose.pose.orientation.x, _x.communication__handle_pose.pose.orientation.y, _x.communication__handle_pose.pose.orientation.z, _x.communication__handle_pose.pose.orientation.w, _x.communication__crank_pose.header.seq, _x.communication__crank_pose.header.stamp.secs, _x.communication__crank_pose.header.stamp.nsecs))
      _x = self.communication__crank_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.communication__crank_pose.pose.position.x, _x.communication__crank_pose.pose.position.y, _x.communication__crank_pose.pose.position.z, _x.communication__crank_pose.pose.orientation.x, _x.communication__crank_pose.pose.orientation.y, _x.communication__crank_pose.pose.orientation.z, _x.communication__crank_pose.pose.orientation.w, _x.communication__drive__controller__current_steering.header.seq, _x.communication__drive__controller__current_steering.header.stamp.secs, _x.communication__drive__controller__current_steering.header.stamp.nsecs))
      _x = self.communication__drive__controller__current_steering.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.communication__drive__controller__current_steering.toruses)
      buff.write(_struct_I.pack(length))
      for val1 in self.communication__drive__controller__current_steering.toruses:
        _v27 = val1.header
        buff.write(_struct_I.pack(_v27.seq))
        _v28 = _v27.stamp
        _x = _v28
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v27.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(val1.failure))
        _v29 = val1.pose
        _v30 = _v29.position
        _x = _v30
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v31 = _v29.orientation
        _x = _v31
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_2d.pack(_x.large_radius, _x.small_radius))
      length = len(self.communication__drive__recognition__predicted_path__marker.markers)
      buff.write(_struct_I.pack(length))
      for val1 in self.communication__drive__recognition__predicted_path__marker.markers:
        _v32 = val1.header
        buff.write(_struct_I.pack(_v32.seq))
        _v33 = _v32.stamp
        _x = _v33
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v32.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.ns
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_3i.pack(_x.id, _x.type, _x.action))
        _v34 = val1.pose
        _v35 = _v34.position
        _x = _v35
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v36 = _v34.orientation
        _x = _v36
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v37 = val1.scale
        _x = _v37
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v38 = val1.color
        _x = _v38
        buff.write(_struct_4f.pack(_x.r, _x.g, _x.b, _x.a))
        _v39 = val1.lifetime
        _x = _v39
        buff.write(_struct_2i.pack(_x.secs, _x.nsecs))
        buff.write(_struct_B.pack(val1.frame_locked))
        length = len(val1.points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.points:
          _x = val2
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        length = len(val1.colors)
        buff.write(_struct_I.pack(length))
        for val2 in val1.colors:
          _x = val2
          buff.write(_struct_4f.pack(_x.r, _x.g, _x.b, _x.a))
        _x = val1.text
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.mesh_resource
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(val1.mesh_use_embedded_materials))
      _x = self
      buff.write(_struct_3I.pack(_x.communication__locomotion_cloud.header.seq, _x.communication__locomotion_cloud.header.stamp.secs, _x.communication__locomotion_cloud.header.stamp.nsecs))
      _x = self.communication__locomotion_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__locomotion_cloud.height, _x.communication__locomotion_cloud.width))
      length = len(self.communication__locomotion_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.communication__locomotion_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.communication__locomotion_cloud.is_bigendian, _x.communication__locomotion_cloud.point_step, _x.communication__locomotion_cloud.row_step))
      _x = self.communication__locomotion_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_B3I.pack(_x.communication__locomotion_cloud.is_dense, _x.communication__normal_flip_cloud.header.seq, _x.communication__normal_flip_cloud.header.stamp.secs, _x.communication__normal_flip_cloud.header.stamp.nsecs))
      _x = self.communication__normal_flip_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.communication__normal_flip_cloud.height, _x.communication__normal_flip_cloud.width))
      length = len(self.communication__normal_flip_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.communication__normal_flip_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        if python3:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.communication__normal_flip_cloud.is_bigendian, _x.communication__normal_flip_cloud.point_step, _x.communication__normal_flip_cloud.row_step))
      _x = self.communication__normal_flip_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.communication__normal_flip_cloud.is_dense))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.communication__point_cloud is None:
        self.communication__point_cloud = sensor_msgs.msg.PointCloud2()
      if self.communication__laser_cloud is None:
        self.communication__laser_cloud = sensor_msgs.msg.PointCloud2()
      if self.communication__image_rect_color is None:
        self.communication__image_rect_color = sensor_msgs.msg.Image()
      if self.communication__camera_info is None:
        self.communication__camera_info = sensor_msgs.msg.CameraInfo()
      if self.communication__image_width_scale is None:
        self.communication__image_width_scale = std_msgs.msg.Float32()
      if self.communication__image_height_scale is None:
        self.communication__image_height_scale = std_msgs.msg.Float32()
      if self.communication__panorama_image is None:
        self.communication__panorama_image = sensor_msgs.msg.Image()
      if self.communication__keyshot_image is None:
        self.communication__keyshot_image = sensor_msgs.msg.Image()
      if self.communication__panorama_width_scale is None:
        self.communication__panorama_width_scale = std_msgs.msg.Float32()
      if self.communication__panorama_height_scale is None:
        self.communication__panorama_height_scale = std_msgs.msg.Float32()
      if self.communication__robot_status is None:
        self.communication__robot_status = std_msgs.msg.UInt8()
      if self.communication__handle_pose is None:
        self.communication__handle_pose = geometry_msgs.msg.PoseStamped()
      if self.communication__crank_pose is None:
        self.communication__crank_pose = geometry_msgs.msg.PoseStamped()
      if self.communication__drive__controller__current_steering is None:
        self.communication__drive__controller__current_steering = jsk_recognition_msgs.msg.TorusArray()
      if self.communication__drive__recognition__predicted_path__marker is None:
        self.communication__drive__recognition__predicted_path__marker = visualization_msgs.msg.MarkerArray()
      if self.communication__locomotion_cloud is None:
        self.communication__locomotion_cloud = sensor_msgs.msg.PointCloud2()
      if self.communication__normal_flip_cloud is None:
        self.communication__normal_flip_cloud = sensor_msgs.msg.PointCloud2()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.communication__point_cloud.header.seq, _x.communication__point_cloud.header.stamp.secs, _x.communication__point_cloud.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__point_cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__point_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__point_cloud.height, _x.communication__point_cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.communication__point_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.communication__point_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.communication__point_cloud.is_bigendian, _x.communication__point_cloud.point_step, _x.communication__point_cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.communication__point_cloud.is_bigendian = bool(self.communication__point_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__point_cloud.data = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.communication__point_cloud.is_dense, _x.communication__laser_cloud.header.seq, _x.communication__laser_cloud.header.stamp.secs, _x.communication__laser_cloud.header.stamp.nsecs,) = _struct_B3I.unpack(str[start:end])
      self.communication__point_cloud.is_dense = bool(self.communication__point_cloud.is_dense)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__laser_cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__laser_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__laser_cloud.height, _x.communication__laser_cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.communication__laser_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.communication__laser_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.communication__laser_cloud.is_bigendian, _x.communication__laser_cloud.point_step, _x.communication__laser_cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.communication__laser_cloud.is_bigendian = bool(self.communication__laser_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__laser_cloud.data = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.communication__laser_cloud.is_dense, _x.communication__image_rect_color.header.seq, _x.communication__image_rect_color.header.stamp.secs, _x.communication__image_rect_color.header.stamp.nsecs,) = _struct_B3I.unpack(str[start:end])
      self.communication__laser_cloud.is_dense = bool(self.communication__laser_cloud.is_dense)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__image_rect_color.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__image_rect_color.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__image_rect_color.height, _x.communication__image_rect_color.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__image_rect_color.encoding = str[start:end].decode('utf-8')
      else:
        self.communication__image_rect_color.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.communication__image_rect_color.is_bigendian, _x.communication__image_rect_color.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__image_rect_color.data = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.communication__camera_info.header.seq, _x.communication__camera_info.header.stamp.secs, _x.communication__camera_info.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__camera_info.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__camera_info.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__camera_info.height, _x.communication__camera_info.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__camera_info.distortion_model = str[start:end].decode('utf-8')
      else:
        self.communication__camera_info.distortion_model = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.communication__camera_info.D = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 72
      self.communication__camera_info.K = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      start = end
      end += 72
      self.communication__camera_info.R = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      start = end
      end += 96
      self.communication__camera_info.P = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=12)
      _x = self
      start = end
      end += 45
      (_x.communication__camera_info.binning_x, _x.communication__camera_info.binning_y, _x.communication__camera_info.roi.x_offset, _x.communication__camera_info.roi.y_offset, _x.communication__camera_info.roi.height, _x.communication__camera_info.roi.width, _x.communication__camera_info.roi.do_rectify, _x.communication__image_width_scale.data, _x.communication__image_height_scale.data, _x.communication__panorama_image.header.seq, _x.communication__panorama_image.header.stamp.secs, _x.communication__panorama_image.header.stamp.nsecs,) = _struct_6IB2f3I.unpack(str[start:end])
      self.communication__camera_info.roi.do_rectify = bool(self.communication__camera_info.roi.do_rectify)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__panorama_image.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__panorama_image.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__panorama_image.height, _x.communication__panorama_image.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__panorama_image.encoding = str[start:end].decode('utf-8')
      else:
        self.communication__panorama_image.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.communication__panorama_image.is_bigendian, _x.communication__panorama_image.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__panorama_image.data = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.communication__keyshot_image.header.seq, _x.communication__keyshot_image.header.stamp.secs, _x.communication__keyshot_image.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__keyshot_image.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__keyshot_image.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__keyshot_image.height, _x.communication__keyshot_image.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__keyshot_image.encoding = str[start:end].decode('utf-8')
      else:
        self.communication__keyshot_image.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.communication__keyshot_image.is_bigendian, _x.communication__keyshot_image.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__keyshot_image.data = str[start:end]
      _x = self
      start = end
      end += 21
      (_x.communication__panorama_width_scale.data, _x.communication__panorama_height_scale.data, _x.communication__robot_status.data, _x.communication__handle_pose.header.seq, _x.communication__handle_pose.header.stamp.secs, _x.communication__handle_pose.header.stamp.nsecs,) = _struct_2fB3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__handle_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__handle_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.communication__handle_pose.pose.position.x, _x.communication__handle_pose.pose.position.y, _x.communication__handle_pose.pose.position.z, _x.communication__handle_pose.pose.orientation.x, _x.communication__handle_pose.pose.orientation.y, _x.communication__handle_pose.pose.orientation.z, _x.communication__handle_pose.pose.orientation.w, _x.communication__crank_pose.header.seq, _x.communication__crank_pose.header.stamp.secs, _x.communication__crank_pose.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__crank_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__crank_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.communication__crank_pose.pose.position.x, _x.communication__crank_pose.pose.position.y, _x.communication__crank_pose.pose.position.z, _x.communication__crank_pose.pose.orientation.x, _x.communication__crank_pose.pose.orientation.y, _x.communication__crank_pose.pose.orientation.z, _x.communication__crank_pose.pose.orientation.w, _x.communication__drive__controller__current_steering.header.seq, _x.communication__drive__controller__current_steering.header.stamp.secs, _x.communication__drive__controller__current_steering.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__drive__controller__current_steering.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__drive__controller__current_steering.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.communication__drive__controller__current_steering.toruses = []
      for i in range(0, length):
        val1 = jsk_recognition_msgs.msg.Torus()
        _v40 = val1.header
        start = end
        end += 4
        (_v40.seq,) = _struct_I.unpack(str[start:end])
        _v41 = _v40.stamp
        _x = _v41
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v40.frame_id = str[start:end].decode('utf-8')
        else:
          _v40.frame_id = str[start:end]
        start = end
        end += 1
        (val1.failure,) = _struct_B.unpack(str[start:end])
        val1.failure = bool(val1.failure)
        _v42 = val1.pose
        _v43 = _v42.position
        _x = _v43
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v44 = _v42.orientation
        _x = _v44
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.large_radius, _x.small_radius,) = _struct_2d.unpack(str[start:end])
        self.communication__drive__controller__current_steering.toruses.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.communication__drive__recognition__predicted_path__marker.markers = []
      for i in range(0, length):
        val1 = visualization_msgs.msg.Marker()
        _v45 = val1.header
        start = end
        end += 4
        (_v45.seq,) = _struct_I.unpack(str[start:end])
        _v46 = _v45.stamp
        _x = _v46
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v45.frame_id = str[start:end].decode('utf-8')
        else:
          _v45.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.ns = str[start:end].decode('utf-8')
        else:
          val1.ns = str[start:end]
        _x = val1
        start = end
        end += 12
        (_x.id, _x.type, _x.action,) = _struct_3i.unpack(str[start:end])
        _v47 = val1.pose
        _v48 = _v47.position
        _x = _v48
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v49 = _v47.orientation
        _x = _v49
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _v50 = val1.scale
        _x = _v50
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v51 = val1.color
        _x = _v51
        start = end
        end += 16
        (_x.r, _x.g, _x.b, _x.a,) = _struct_4f.unpack(str[start:end])
        _v52 = val1.lifetime
        _x = _v52
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2i.unpack(str[start:end])
        start = end
        end += 1
        (val1.frame_locked,) = _struct_B.unpack(str[start:end])
        val1.frame_locked = bool(val1.frame_locked)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          val1.points.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.colors = []
        for i in range(0, length):
          val2 = std_msgs.msg.ColorRGBA()
          _x = val2
          start = end
          end += 16
          (_x.r, _x.g, _x.b, _x.a,) = _struct_4f.unpack(str[start:end])
          val1.colors.append(val2)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.text = str[start:end].decode('utf-8')
        else:
          val1.text = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.mesh_resource = str[start:end].decode('utf-8')
        else:
          val1.mesh_resource = str[start:end]
        start = end
        end += 1
        (val1.mesh_use_embedded_materials,) = _struct_B.unpack(str[start:end])
        val1.mesh_use_embedded_materials = bool(val1.mesh_use_embedded_materials)
        self.communication__drive__recognition__predicted_path__marker.markers.append(val1)
      _x = self
      start = end
      end += 12
      (_x.communication__locomotion_cloud.header.seq, _x.communication__locomotion_cloud.header.stamp.secs, _x.communication__locomotion_cloud.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__locomotion_cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__locomotion_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__locomotion_cloud.height, _x.communication__locomotion_cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.communication__locomotion_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.communication__locomotion_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.communication__locomotion_cloud.is_bigendian, _x.communication__locomotion_cloud.point_step, _x.communication__locomotion_cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.communication__locomotion_cloud.is_bigendian = bool(self.communication__locomotion_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__locomotion_cloud.data = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.communication__locomotion_cloud.is_dense, _x.communication__normal_flip_cloud.header.seq, _x.communication__normal_flip_cloud.header.stamp.secs, _x.communication__normal_flip_cloud.header.stamp.nsecs,) = _struct_B3I.unpack(str[start:end])
      self.communication__locomotion_cloud.is_dense = bool(self.communication__locomotion_cloud.is_dense)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.communication__normal_flip_cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.communication__normal_flip_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.communication__normal_flip_cloud.height, _x.communication__normal_flip_cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.communication__normal_flip_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.communication__normal_flip_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.communication__normal_flip_cloud.is_bigendian, _x.communication__normal_flip_cloud.point_step, _x.communication__normal_flip_cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.communication__normal_flip_cloud.is_bigendian = bool(self.communication__normal_flip_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.communication__normal_flip_cloud.data = str[start:end]
      start = end
      end += 1
      (self.communication__normal_flip_cloud.is_dense,) = _struct_B.unpack(str[start:end])
      self.communication__normal_flip_cloud.is_dense = bool(self.communication__normal_flip_cloud.is_dense)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_7d3I = struct.Struct("<7d3I")
_struct_IBI = struct.Struct("<IBI")
_struct_2fB3I = struct.Struct("<2fB3I")
_struct_12d = struct.Struct("<12d")
_struct_3i = struct.Struct("<3i")
_struct_2i = struct.Struct("<2i")
_struct_6IB2f3I = struct.Struct("<6IB2f3I")
_struct_BI = struct.Struct("<BI")
_struct_9d = struct.Struct("<9d")
_struct_2d = struct.Struct("<2d")
_struct_3I = struct.Struct("<3I")
_struct_B = struct.Struct("<B")
_struct_B3I = struct.Struct("<B3I")
_struct_B2I = struct.Struct("<B2I")
_struct_4f = struct.Struct("<4f")
_struct_4d = struct.Struct("<4d")
_struct_2I = struct.Struct("<2I")
_struct_3d = struct.Struct("<3d")
